using System;



namespace ConsoleApp11

{

    class Program

    {

        static void Main(string[] args)

        {



            int n = int.Parse(Console.ReadLine());

            string [] Brojpacijenata = new string[n];

            string[] Pacijentudato = new string[n];

            string[] grupe = Console.ReadLine().Split();

           

            int O = int.Parse(grupe[0]);

            int A = int.Parse(grupe[1]);

            int B = int.Parse(grupe[2]);

            int AB = int.Parse(grupe[3]);



            string[] pacijent;

            string krvnagrupa;

            int jedinica;

            int nemoguce = 0;



            for (int i = 0; i < n; i++)

            {

                pacijent = Console.ReadLine().Split(" " );

                krvnagrupa = pacijent[0];

                jedinica = int.Parse(pacijent[1]);

                Pacijentudato[i] = (0, 0, 0, 0).ToString();



                if (krvnagrupa == "O")

                    Brojpacijenata[i] = (0,jedinica,0,0,0,0).ToString();

                else if (krvnagrupa == "A")

                    Brojpacijenata[i] = (0,0,jedinica,0,0,0).ToString();

                else if (krvnagrupa == "B")

                    Brojpacijenata[i] = (0,0,0,jedinica,0,0).ToString();

                else if (krvnagrupa == "AB")

                    Brojpacijenata[i] = (0,0,0,0,jedinica,0).ToString();

                            }



            for (int i = 0; i < n; i++)

            {

                string[] str1 = Brojpacijenata[i].Split(", ");

                int Opotrebno = int.Parse(str1[1]);

                int Apotrebno = int.Parse(str1[2]);

                int Bpotrebno = int.Parse(str1[3]);

                int ABpotrebno = int.Parse(str1[4]);



                int Odato = 0;

                int Adato = 0;

                int Bdato = 0;

                int ABdato = 0;



                while (Opotrebno>0 && O > 0)

                {

                    Opotrebno--;

                    O--;

                    Odato++;

                }

                if (Opotrebno > 0)

                {

                    nemoguce++;

                    Console.WriteLine("nemoguce");

                    break;

                }







                while (Apotrebno > 0 && O>0)

                {

                    Apotrebno--;

                    O--;

                    Odato++;

                }

                while (Apotrebno > 0 && A>0)

                {

                    Apotrebno--;

                    A--;

                    Adato++;

                }

                if (Apotrebno > 0)

                {

                    nemoguce++;

                    Console.WriteLine("nemoguce");

                    break;

                }







                while (Bpotrebno > 0 && O > 0)

                {

                    Bpotrebno--;

                    O--;

                    Odato++;

                }

                while (Bpotrebno > 0 && A > 0)

                {

                    Bpotrebno--;

                    A--;

                    Adato++;

                }

                while (Bpotrebno > 0 && B > 0)

                {

                    Bpotrebno--;

                    B--;

                    Bdato++;

                }

                if (Bpotrebno > 0)

                {

                    nemoguce++;

                    Console.WriteLine("nemoguce");

                    break;

                }







                while (ABpotrebno > 0 && O > 0)

                {

                    ABpotrebno--;

                    O--;

                    Odato++;

                }

                while (ABpotrebno > 0 && A > 0)

                {

                    ABpotrebno--;

                    A--;

                    Adato++;

                }

                while (ABpotrebno > 0 && B > 0)

                {

                    ABpotrebno--;

                    B--;

                    Bdato++;

                }

                while (ABpotrebno > 0 && AB > 0)

                {

                    ABpotrebno--;

                    AB--;

                    ABdato++;

                }

                if (ABpotrebno > 0)

                {

                    nemoguce++;

                    Console.WriteLine("nemoguce");

                    break;

                }







                Pacijentudato[i] = (0,Odato,Adato,Bdato,ABdato,0).ToString();

            }



            if (nemoguce < 1)

            {

                Console.WriteLine("moguce");

                for (int i = 0; i < n; i++)

                {

                    string[] str3 = Pacijentudato[i].Split(",");



                    int Odato = int.Parse(str3[1]);

                    int Adato = int.Parse(str3[2]);

                    int Bdato = int.Parse(str3[3]);

                    int ABdato = int.Parse(str3[4]);

                    Console.WriteLine(Odato + " " + Adato + " " + Bdato + " " + ABdato);



                }



            }



        }

    }

}